$SIG{'INT'} = 'INT_handler';


open(CONFLICT, ">conflicts.txt") or die "No Conflict.txt Created\n"; 

$maxHop = 1.0;
$maxXValue = 8;
$maxYValue = 8;
$minXValue = 1;
$minYValue = 1;

$numOfSimMobileNodes = 5;

$MAX_INTERVAL_SIZE = 10;
$MAX_NO_OF_NODES_IN_GRID = 64;
$MAX_ANGLE = 360;
$MAX_EXP_TIME = 200;

# noOfHopsAfterWhichSpeedIsChanged
# mobileDirection 

# sizeOfAnInterval 
# Presently set to 10

$numMobiles = 0;

$redo = 0;

#The hash that stores everything !
%store = ();

# For each mobile select a random speed (length of interval before switching takes place) and a random angle (0 - 360). Given an x,y.. the co-ordinate of the# next node is calculated by calculating the slope as per the randomly selected angle and using the equation y = mx. If the direction is in (0,90) or (270,360) the mobile is assumed to move in the forward direction, and the next x co-ord is x+1. The corresponding y co-ord can be calculated using y=mx.
# We also define the maximum time for the experiment.
# In case the mobile hits the grid boundary or hits a node that is already occupied... the angle of the mobile is reselected randomly. The number of hops after which the speed should be reselected is specific for a mobile and may also be randomly selected.

while($numMobiles < $numOfSimMobileNodes)
{
	open(RAND, "/dev/random") or die "No /dev/random?\n"; 
	read(RAND,$seed,4); 
	close(RAND);
	srand(unpack("L", $seed));
	#print CONFLICT "Seed = ", unpack("H*", $seed) , "\n"; 

#	#print CONFLICT " The Interval Count is $intervalCount\n";

#Just an Index
	$intervalCount = 0;
	$intervalTime = 0;
	$maxRandomTries = 0;

	do
	{
#$numberOfHops = rand $MAX_NO_OF_NODES_IN_GRID;
		$numberOfHops = int(rand ($MAX_NO_OF_NODES_IN_GRID/32));

	}while ($numberOfHops == 0);

	$noOfHopsAfterWhichSpeedIsChanged = int($numberOfHops);

	do
	{
		$mobileDirection = int(rand $MAX_ANGLE);
	}
	while($mobileDirection == 90 || $mobileDirection == 270);

#$mobileDirection = int(rand $MAX_ANGLE);

	do
	{
		$sizeOfAnInterval = int(rand $MAX_INTERVAL_SIZE + 0.5);
	}while ($sizeOfAnInterval <= 0);

	#print CONFLICT "The No Of Hops after which the speed for $numMobiles is changed is $noOfHopsAfterWhichSpeedIsChanged\n";
	#print CONFLICT "The Initial Angle that the mobile $numMobiles will move in $mobileDirection \n";
# The size of interval at which switching takes place decides the speed of the mobile
	#print CONFLICT "The Interval Size for $numMobiles is $sizeOfAnInterval \n"; 

	do
	{
		$x0 = int(rand $maxXValue);
	}while($x0 == 0);

	do
	{
		$y0 = int(rand $maxYValue);
	}while($y0 == 0);

	$x = $x0;
	$y = $y0;

	$noOfHops = 0;

	$changedMobDirection = 1;

	while($intervalTime <= $MAX_EXP_TIME)
	{
		if($changedMobDirection == 0)
		{
			$nodeNameAndTime = "$intervalTime node$x-$y";
			push @{$store{$numMobiles}}, $nodeNameAndTime;
			#print CONFLICT "The Nodename and Time for $numMobiles is $nodeNameAndTime \n"; 
			$intervalTime = $intervalTime + $sizeOfAnInterval;
			$noOfHops = $noOfHops + 1;

##### Calculate the next x-y co-ord for the mobile

			if($noOfHops > $noOfHopsAfterWhichSpeedIsChanged)
			{
				do
				{
					$sizeOfAnInterval = int(rand $MAX_INTERVAL_SIZE + 0.5);
				}
				while ($sizeOfAnInterval <= 0);

				#print CONFLICT "The Changed Interval Size for Mobile $numMobiles is $sizeOfAnInterval \n"; 
				$noOfHops = 0;
			}
		}

		$dx = abs(cos($mobileDirection))/cos($mobileDirection);
		$tempx = int($x + $maxHop * $dx);
		if($tempx > $maxXValue || $tempx < $minXValue)
		{
			$changedMobDirection = 1;
			do
			{
				$mobileDirection = int(rand $MAX_ANGLE);
			}
			while($mobileDirection == 90 || $mobileDirection == 270);
			next;
		}

		#print CONFLICT " The value of dx is $dx\n";

		#print CONFLICT " The value of tempx is $tempx\n";

		$tempy = int((sin($mobileDirection)/cos($mobileDirection)) * ($tempx - $x) + $y);

		#print CONFLICT " The value of tempy is $tempy\n";

		if($tempy > $maxYValue || $tempy < $minYValue)
		{
			$changedMobDirection = 1;
			do
			{
				$mobileDirection = int(rand $MAX_ANGLE);
			}
			while($mobileDirection == 90 || $mobileDirection == 270);

			next;

			#print "FROM IF\n";
		}
		elsif (0 != isUnique($numMobiles , $intervalTime, $sizeOfAnInterval, "node$tempx-$tempy"))
		{
			$maxRandomTries = $maxRandomTries + 1;
			if($maxRandomTries > 10)
			{
				#print CONFLICT  "MORE THAN 10 RETRIES... WILL CARRY OUT A LINEAR SEARCH\n";
# Will carry out a linear search
				$indx = $x;
				$indy = $y;
				for($indx=$x;$changedMobDirection != 0, $indx<=$maxXValue, $indx<=$x+$maxHop;$indx++)
				{
					for($indy=$y;$changedMobDirection != 0, $indy<=$maxYValue, $indy<=$y+$maxHop;$indy++)
					{
						if(0 == isUnique($numMobiles , $intervalTime, $sizeOfAnInterval, "node$indx-$indy"))
						{
							$changedMobDirection = 0;
						}
					}
				}

				if($changedMobDirection != 0)
				{
					for($indx=$x;$changedMobDirection != 0, $indx>=$minXValue, $indx>=$x-$maxHop;$indx--)
					{
						for($indy=$y;$changedMobDirection != 0, $indy>=$minYValue, $indy>=$y-$maxHop;$indy--)
						{
							if(0 == isUnique($numMobiles , $intervalTime, $sizeOfAnInterval, "node$indx-$indy"))
							{
								$changedMobDirection = 0;
							}
						}
					}
				}

				if($changedMobDirection != 0)
				{
					$tempx = $x;
					$tempy = $y;
					$changedMobDirection = 0;
					#print CONFLICT "NOT CHANGING THE NODE. STAYING on node$x-$y\n";
				}

				$maxRandomTries = 0;
			}
			else
			{
				$changedMobDirection = 1;

				do
				{
					$mobileDirection = int(rand $MAX_ANGLE);
				}
				while($mobileDirection == 90 || $mobileDirection == 270);

#$x = $tempx;
#$y = $tempy;
			}
			#print "FROM IFELSE\n";
		}
		else
		{
			$changedMobDirection = 0;
			#print "FROM ELSE\n";
		}


		if($changedMobDirection == 0)
		{
			if($tempx > $maxXValue)
			{
			exit;
			}
			$x = $tempx;
			$y = $tempy;
		}

	}
	#print CONFLICT " Processed Mobile $numMobiles\n";
	print " Processed Mobile $numMobiles\n";
	$numMobiles =  $numMobiles + 1;
}

sub isUnique
{
	$i = 0;

	$count = $_[0];
	$intTimeStart = $_[1];
	$sizeOfInt = $_[2];
	$nodeToBeCmp = $_[3];

	$intTimeEnd = $intTimeStart + $sizeOfInt;

	#print CONFLICT " Entered Unique \n";

	#print CONFLICT " The interval time start is $intTimeStart\n";
	#print CONFLICT " The interval time end is $intTimeEnd\n";

	while($i <= $numOfSimMobileNodes)
	{
		$possibleConflict = 0;
		$j = 0;

		while (${$store{$i}}[$j] ne ())
		{
			($timeVar, $nodeName) = split(/ /, ${$store{$i}}[$j]);

			#print CONFLICT " The node to be compared is Sanjit-$nodeToBeCmp-Sanjit\n";
			#print CONFLICT " The other node to be compared is Sanjit-$nodeName-Sanjit\n";

			if($possibleConflict == 0 && $nodeToBeCmp =~ /$nodeName/)
			{
				$possibleConflict = 1;
				$conflictDetectedStart = $timeVar;
				#print CONFLICT " The conflictDetectedStart Sanjit-$conflictDetectedStart-Sanjit\n";
			}
			elsif($possibleConflict == 1)
			{
				$possibleConflict = 2;
				$conflictDetectedEnd = $timeVar;
				#print CONFLICT " The conflictDetectedEnd Sanjit-$conflictDetectedEnd-Sanjit\n";
			}

			$j = $j + 1;

			if($possibleConflict == 2)
			{
				if($conflictDetectedStart <= $intTimeStart && ($conflictDetectedEnd > $intTimeStart && $conflictDetectedEnd <= $intTimeEnd))
				{
# Conflict

					#print CONFLICT "Found Conflict1 -- Conflicting Intervals are \($conflictDetectedStart, $conflictDetectedEnd\) of Mobile $i \&\& \($intTimeStart, $intTimeEnd\)\n"; 
				}
				elsif($conflictDetectedStart >= $intTimeStart && $conflictDetectedEnd <= $intTimeEnd)
				{
# Conflict
					#print CONFLICT "Found Conflict2 -- Conflicting Intervals are \($conflictDetectedStart, $conflictDetectedEnd\) of Mobile $i \&\& \($intTimeStart, $intTimeEnd\)\n"; 
				}
				elsif($conflictDetectedStart >= $intTimeStart && $conflictDetectedStart < $intTimeEnd && $conflictDetectedEnd >= $intTimeEnd)
				{
# Conflict
					#print CONFLICT "Found Conflict3 -- Conflicting Intervals are \($conflictDetectedStart, $conflictDetectedEnd\) of Mobile $i \&\& \($intTimeStart, $intTimeEnd\)\n"; 
				}
				else
				{
					$possibleConflict = 0;
					$j = $j - 1;
				}
			}

			if($possibleConflict == 2)
			{
				#print CONFLICT "The possibleconflict is $possibleConflict\n";
				return $possibleConflict;
			}
			elsif($timeVar >= $intTimeEnd)
			{
				$possibleConflict = 0;			
				last;
			}
		}
		if($possibleConflict == 1)
		{
			#print CONFLICT "The possibleconflict is $possibleConflict\n";
			return $possibleConflict;
		}
		$i = $i + 1;

	}
	$possibleConflict = 0;
	return 0;
}


##print "###################  What The Grid Looks Like #####\n";


$j = 0;
$i = 0;

while($i <= $numOfSimMobileNodes)
{
	$j = 0;
	while (${$store{$i}}[$j] ne ())
	{
		$fileIndex = $i + 1;
		$str = ${$store{$i}}[$j];
		system("echo $str >> VM$fileIndex.txt");
		print "${$store{$i}}[$j]\n";
		$j = $j + 1;
	}
	print "\n";
	$i = $i + 1;

}

sub INT_handler
{
	$j = 0;
	$i = 0;

	while($i <= $numOfSimMobileNodes)
	{
		$j = 0;
		while (${$store{$i}}[$j] ne ())
		{
			system("echo ${$store{$i}}[$j]\n >> VM$i.txt");
			$j = $j + 1;
		}
		print "\n";
		$i = $i + 1;

	}

	exit 0;


}
